# platform-catch-crs

This repository will contain all of the files that define Coordinate References Systems, as well as the script to generate and compare the files.

<br />

## Generating the files
If you want to run these scripts yourself READ THE FOLLOWING SECTION :
- [Setting up SRS](#setting-up-srs)

Once SRS is setup you can just execute the scripts like any other python script.

### Running the generator script
You can specify an out directory with -o or --out.
This can either be a fully qualified path, or partial to where the script is being run
- Qualified : /home/generated   -> will write files to /home/generated
- Partial   : /generated        -> will write files to /home/user/platform-catch-crs/generated (for example)

THIS SCRIPT WILL OVERWRITE FILES, but will warn you if it may.

This script may take quite a few minutes to run.

### Running the comparator script
There doesn't seem to be any way to ... CRON Github Actions
After running the generator, you can

## Using site localisation

It require to have a least the version 4.4.0 of SRS.

Once ready, you can run `python3.8 site-localization.py [-n filename]` 
In order to use your own data, you can change the following:
- **srs_in**: The CRS of the global points
- **v_ref**: The global coordinates
- **v_site**: The local coordinates

This will generate a file, named *filename.wkt*, in the current folder. This wkt2 can then be used in the future.
Also, it prints the RMS and max residuals, in case it is needed.

<br /><br />

## Using SRS
You can get an idea of how to work with SRS in python in the srs-tests file.

[The SRS Altlassian pages](https://pix4dbug.atlassian.net/wiki/spaces/GEO/pages/823820569/Coordinate+Systems+Library) aren't much help.

A previous version of the page does give some indication: https://pix4dbug.atlassian.net/wiki/pages/viewpage.action?pageId=823820569&pageVersion=14

The best source on using SRS was the python tests file: https://github.com/Pix4D/pix4d-spatial-ref-sys/blob/master/libs/srs/tests/python/test_srs.py

The different wheel can be found here: https://artifactory.ci.pix4d.com/ui/repos/tree/General/pix4d-pypi-local/pix4dsrs (require VPN)


<br /><br />

## Setting up SRS

### Running SRS in a windows machine
If you prefer, [the catch team has a windows machine](https://pix4dbug.atlassian.net/wiki/spaces/Catch/pages/3715727449/Desktop+machines) that you can [connect to](https://docs.microsoft.com/en-us/windows-server/remote/remote-desktop-services/clients/remote-desktop-mac).


<br /><br />

### Running SRS in a VM
SRS can only be run on x86_64 machines, and is only guaranteed to work on Ubuntu (Server is the best choice when emulating on M-X macs).
To run on a Mac, the easiest is on a [UTM virtual machine](https://mac.getutm.app).

Make sure to download an x86_64 version of the OS, as when downloading from M-X macs the default download will be ARM.


<br /><br />

#### Install Python 3.8
The SRS library requires Python 3.8.

Ubuntu's repos don't have the newest version of Python, so you'll have to add one that does. A good choice is deadsnakes:

`sudo add-apt-repository ppa:deadsnakes/ppa`

Verify that the package exists:

`apt list | grep python3.8`

If there are available python3.8 packages, you can go ahead and install python3.9, along with python3.8-distutils:

`sudo apt install python3.8 python3.8-distutils`

If you don't want to switch out your existing version of python3, you can call any command with python3.8, including pip as follows:

`python3.8 -m pip install pix4dsrs`

NOTE : [setting up artifactory can be a pain](https://pix4dbug.atlassian.net/wiki/spaces/INT/pages/2221441063/How+to+use+Pix4D+PyPi), I just downloaded the wheel file from artifactory instead. You can the just use pip to install the wheel.

You can then install the wheel like a package:

`python3.8 -m pip install pix4dsrs-cp38-cp38-whatever.whl`


<br /><br />

#### Remote Development - SSH & Port Forwarding
If you used Ubuntu Server as suggested, you can use an IDE like Visual Studio Code on the Host OS, and ssh into the Guest OS for an easier development experience (hey, beats nano!).

Make sure that you have setup your SSH keys on the Guest OS with ssh-keygen.

Edit the VM in UTM (while the VM isn't running), and go to the Network section. 
- Change the Network Mode to "Emulated VLAN"
- Add a new Port Forward, with the following information
    - Guest Address : 0.0.0.0
    - Guest Port : 22
    - Host Address : 127.0.0.2
    - Host Port 2200 (note : this can be any unused port)

Now you should be able to SSH into the Guest OS from the Host OS through port 2200 (or whatever port you entered):
`ssh guest_os_user@localhost -p 2200`


<br /><br />

#### Host - Guest File Sharing
You can use DAVFS to easily share files between the Host and Guest OS.
Make sure to install the Spice packages on the Guest OS :
`sudo apt install spice-vdagent spice-webdavd`

You can then mount the folder in the guest OS with (if you have davfs installed):

`sudo mount -t davfs ${WEBDAV_SERVER_URL} /${FOLDER_DESTINATION}`
