//
//  PlatformCatchCRSTests.swift
//  
//
//  Created by George Brown on 15.11.22.
//

import XCTest
@testable import platform_catch_crs_swift

final class PlatformCatchCRSTests: XCTestCase {

    override func setUpWithError() throws {
        // Put setup code here. This method is called before the invocation of each test method in the class.
    }

    override func tearDownWithError() throws {
        // Put teardown code here. This method is called after the invocation of each test method in the class.
    }

    func testURLS() throws {
        XCTAssertNotNil(PlatformCatchCRS.Source.geographic.sourceURL)
        XCTAssertNotNil(PlatformCatchCRS.Source.projected.sourceURL)
        XCTAssertNotNil(PlatformCatchCRS.Source.vertical.sourceURL)
    }
    
    func testLoadProjectedCRS() throws {
        let crs = try PlatformCatchCRS.loadCRS(from: .projected)
        XCTAssertFalse(crs.isEmpty)
        let filtered = crs.filter { $0.type == .projected }
        XCTAssertEqual(crs.count, filtered.count)
    }
    
    func testLoadGeographicCRS() throws {
        let crs = try PlatformCatchCRS.loadCRS(from: .geographic)
        XCTAssertFalse(crs.isEmpty)
        let filtered = crs.filter { $0.type == .geographic }
        XCTAssertEqual(crs.count, filtered.count)
    }
    
    func testLoadVerticalCRS() throws {
        let crs = try PlatformCatchCRS.loadCRS(from: .vertical)
        XCTAssertFalse(crs.isEmpty)
        let filtered = crs.filter { $0.type == .vertical }
        XCTAssertEqual(crs.count, filtered.count)
    }

}
